﻿using Newtonsoft.Json;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Timers;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Bellwether.Pages
{
    /// <summary>
    /// Interaction logic for ucFrontPage.xaml
    /// </summary>
    public partial class ucFrontPage : UserControl
    {
        public event EventHandler<PageType> GoPageRequested;

        private Timer SolarInfpoUpdateTimer;

        public ucFrontPage()
        {
            InitializeComponent();

            SolarInfpoUpdateTimer = new Timer() { Interval = 60_0000 };

            Loaded += UcFrontPage_Load;
            Unloaded += UcFrontPage_Unload;
        }

        private void UcFrontPage_Load(object sender, EventArgs e)
        {
            SolarInfpoUpdateTimer.Elapsed += SolarInfpoUpdateTimer_Elapsed;

            UpdateSolarInfo();
            SolarInfpoUpdateTimer.Start();
        }

        private void UcFrontPage_Unload(object sender, EventArgs e)
        {
            SolarInfpoUpdateTimer.Elapsed -= SolarInfpoUpdateTimer_Elapsed;
            SolarInfpoUpdateTimer.Stop();
        }

        private void SolarInfpoUpdateTimer_Elapsed(object sender, ElapsedEventArgs e)
        {
            UpdateSolarInfo();
        }

        private void UpdateSolarInfo()
        {
            var client = new RestSharp.RestClient("https://dsegomspoctestenv.azurewebsites.net/api/siteoverview?act=9237&token=BWsolarenergy");
            var request = new RestSharp.RestRequest(RestSharp.Method.GET);
            //request.AddParameter("act", "9237");
            //request.AddParameter("token", "BWsolarenergy");

            var response = client.Execute(request);

            if (response.IsSuccessful)
            {
                var result = response.Content;

                if (result.StartsWith("\""))
                {
                    result = result.Substring(1);
                }
                if (result.EndsWith("\""))
                {
                    result = result.Substring(0,result.Length - 1);
                }
                result = result.Replace("\\\"", "\"");

                try
                {
                    var data = JsonConvert.DeserializeObject<SolarInfoModel>(result);

                    if (data !=null)
                    {

                    }
                }
                catch(Exception e)
                {
                    return;
                }
            }
            else
            {
                var errmsg = response.Content;
            }
        }

        private void Button_Click(object sender, RoutedEventArgs e)
        {
            GoPageRequested?.Invoke(this, PageType.History);
        }

        private void Button1_Click(object sender, RoutedEventArgs e)
        {
            GoPageRequested?.Invoke(this, PageType.Product);
        }

        private void Button2_Click(object sender, RoutedEventArgs e)
        {
            GoPageRequested?.Invoke(this, PageType.CSR);
        }
    }

    public class SolarInfoModel
    {
        public float Capacity { get; set; }
        public double Energy_Today { get; set; }
        public double CO2EmissionSaved_Today { get; set; }
        public double EquivalentTreesPlanted_Today { get; set; }
        public double Energy_ThisYear { get; set; }
        public double CO2EmissionSaved_ThisYear { get; set; }
        public double EquivalentTreesPlanted_ThisYear { get; set; }
    }
}
